//+------------------------------------------------------------------+
//|                                               Equity_virtual.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               11.09.2009 |
//|                                 http://codebase.mql4.com/ru/5389 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 SteelBlue
#property indicator_color3 OrangeRed
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1

//-------------  
extern string   Default_Symbols=""; //          ,    ,       
extern double   Default_Lot=0.1;    //    ,            
extern bool     Use_M1=false;       //       
extern bool     Open_Price=true;    //       ,  -  
extern bool     Use_MM=false;       //  Money Management (    )
extern int      Deposit=10000;      //  

//-------------   
extern bool     Show_Total=true;    //    ()
extern bool     Show_Buy=false;     //    buy (  )
extern bool     Show_Sell=false;    //    sell (  )
extern bool     Show_Info=false;    //       
extern bool     Show_Vline=false;   //      / 
extern color    Trend_Color=Blue;   //   ,   
extern color    Revers_Color=Red;   //   ,      

//-------------    
extern double   Alert_Drawdown=0;   //         (0 - )
extern double   Max_Drawdown=25;    //        (" ")
extern bool     Current_Day=true;   //       
extern datetime Begin_Monitoring=D'2009.08.17 00:00'; //     ( Current_Day=false)

//-------------   
extern int      Time_Refresh=3;     //     ,         
extern datetime Time_Begin=D'2001.01.01 01:01'; //    
extern datetime Time_End=D'2011.11.11 11:11';   //    

//              .
//      ,     (Default_Symbols)   .
//        .       / .
//         ,      (EURUSD+ GBPUSD-).
//       (EURUSD+1 GBPUSD-0.7).     ,     (Default_Lot).
//         .
//      .   ,        .
//       .  "!"         .
//          .

int      Pos_Total,Trend_Total,Vline_Total,Window;
string   ShortName,Unique,Vline_Name[];
double   TotalEquity[],BuyEquity[],SellEquity[];
double   BuyBalance,SellBalance,PrevEquity,MaxPeak,MaxProfit;
double   AbsDrawdown,MaxDrawdown,RelDrawdown,Drawdown,RecoveryFactor;
datetime Vline_Time[];

int      OpenBar[];    //   
int      CloseBar[];   //   
int      Type[];       //  
string   Instrument[]; // 
double   Lots[];       //  
double   OpenPrice[];  //  
double   ClosePrice[]; //  

//+------------------------------------------------------------------+
//|  Custom indicator initialization function                        |
//+------------------------------------------------------------------+
int init()
{
 SetIndexBuffer(0,TotalEquity);
 SetIndexLabel(0,"Total");
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(1,BuyEquity);
 SetIndexLabel(1,"Buy");
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(2,SellEquity);
 SetIndexLabel(2,"Sell");
 SetIndexStyle(2,DRAW_LINE);
 ShortName="Equity_virtual";
 if (Show_Total) ShortName=StringConcatenate(ShortName," Total");
 if (Show_Buy)   ShortName=StringConcatenate(ShortName," Buy");
 if (Show_Sell)  ShortName=StringConcatenate(ShortName," Sell");
 Unique=DoubleToStr(GetTickCount()+MathRand(),0);
 IndicatorShortName(ShortName);
 IndicatorDigits(2);
 return(0);
}
//+------------------------------------------------------------------+
//|  Custom indicator deinitialization function                      |
//+------------------------------------------------------------------+
int deinit()
{
 int total=ObjectsTotal()-1;
 for (int i=total;i>=0;i--)
 {
  string name=ObjectName(i);
  if (StringFind(name,Unique)!=-1) ObjectDelete(name);
 }
 return(0);
}
//+------------------------------------------------------------------+
//|  Custom indicator iteration function                             |
//+------------------------------------------------------------------+
int start()
{
 string objectname,text;
 static string minfosymbols="";
 double buyprofitloss,sellprofitloss,spread,lotsize;
 int bar,i,j,start,finish;
 color objectcolor;
 static int tick;

 if (GetTickCount()-tick>Time_Refresh*1000) tick=GetTickCount();
 else return(0);
 Pos_Total=0;
 Trend_Total=0;
 Vline_Total=0;
 for (i=0;i<ObjectsTotal();i++)
 {
  objectname=ObjectName(i);
  if (ObjectFind(objectname)>0) continue;
  if (ObjectType(objectname)!=OBJ_TREND) continue;
  objectcolor=ObjectGet(objectname,OBJPROP_COLOR);
  if (objectcolor==Trend_Color || objectcolor==Revers_Color) SetPosition(objectname);
 }
 for (i=Vline_Total-1;i>=0;i--)
 {
  if (Show_Vline)
  {
   ObjectCreate(Vline_Name[i],OBJ_VLINE,0,Vline_Time[i],0);
   ObjectSetText(Vline_Name[i],Vline_Name[i]);
  }
  else ObjectDelete(Vline_Name[i]);
 }
 if (!Show_Vline && Vline_Total>0)
 {
  ArrayResize(Vline_Name,0);
  ArrayResize(Vline_Time,0);
 }
 if (ArraySize(OpenBar)>Pos_Total)
 {
  ArrayResize(OpenBar,Pos_Total);
  ArrayResize(Instrument,Pos_Total);
  ArrayResize(Type,Pos_Total);
  ArrayResize(OpenPrice,Pos_Total);
  ArrayResize(Lots,Pos_Total);
  ArrayResize(CloseBar,Pos_Total);
  ArrayResize(ClosePrice,Pos_Total);
 }
 if (Show_Total) ArrayInitialize(TotalEquity,Deposit);
 if (Show_Buy)   ArrayInitialize(BuyEquity,Deposit);
 if (Show_Sell)  ArrayInitialize(SellEquity,Deposit);
 if (Pos_Total==0) return(0);
 MaxPeak=0.0;
 MaxProfit=0.0;
 AbsDrawdown=0.0;
 MaxDrawdown=0.0;
 RelDrawdown=0.0;
 BuyBalance=0.0;
 SellBalance=0.0;
 PrevEquity=Deposit;
 start=OpenBar[ArrayMaximum(OpenBar)];
 finish=iBarShift(NULL,0,Time_End);
 for (i=start;i>=finish;i--)
 {
  buyprofitloss=0.0;
  sellprofitloss=0.0;
  for (j=0;j<Pos_Total;j++)
  {
   if (OpenBar[j]>=i && CloseBar[j]<=i)
   {
    if (MarketInfo(Instrument[j],MODE_POINT)==0)
    {
     if (StringFind(minfosymbols,Instrument[j])==-1)
     {
      Alert("     "+Instrument[j]);
      minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
     }
     continue;
    }
    bar=iBarShift(Instrument[j],0,Time[i]);
    lotsize=LotSize(Instrument[j],Time[i]);
    if (Use_MM && OpenBar[j]==i) Lots[j]=NormalizeDouble(PrevEquity/1000*Lots[j],2);
    if (Type[j]==OP_BUY)
    {
     if (CloseBar[j]==i) BuyBalance+=(ClosePrice[j]-OpenPrice[j])*Lots[j]*lotsize;
     else buyprofitloss+=(iClose(Instrument[j],0,bar)-OpenPrice[j])*Lots[j]*lotsize;
    } 
    else
    {
     spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
     if (CloseBar[j]==i) SellBalance+=(OpenPrice[j]-ClosePrice[j]-spread)*Lots[j]*lotsize;
     else sellprofitloss+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread)*Lots[j]*lotsize;
    }
   }
  }
  PrevEquity=NormalizeDouble(Deposit+BuyBalance+SellBalance+buyprofitloss+sellprofitloss,2);
  if (Show_Total) TotalEquity[i]=PrevEquity;
  if (Show_Buy)   BuyEquity[i]=NormalizeDouble(Deposit+BuyBalance+buyprofitloss,2);
  if (Show_Sell)  SellEquity[i]=NormalizeDouble(Deposit+SellBalance+sellprofitloss,2);
  if (Show_Info)  Drawdown(PrevEquity);
 }
 IndicatorShortName(Unique);
 Window=WindowFind(Unique);
 IndicatorShortName(ShortName);
 
 objectname=StringConcatenate("Total Equity ",Unique);
 if (Show_Total)
 {
  if (ObjectFind(objectname)==-1)
  {
   ObjectCreate(objectname,OBJ_HLINE,Window,0,TotalEquity[0]);
   ObjectSet(objectname,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet(objectname,OBJPROP_COLOR,LimeGreen);
  }
  ObjectSet(objectname,OBJPROP_PRICE1,TotalEquity[0]);
 }
 else if (ObjectFind(objectname)!=-1) ObjectDelete(objectname);
 
 objectname=StringConcatenate("Buy Equity ",Unique);
 if (Show_Buy)
 {
  if (ObjectFind(objectname)==-1)
  {
   ObjectCreate(objectname,OBJ_HLINE,Window,0,BuyEquity[0]);
   ObjectSet(objectname,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet(objectname,OBJPROP_COLOR,SteelBlue);
  }
  ObjectSet(objectname,OBJPROP_PRICE1,BuyEquity[0]);
 }
 else if (ObjectFind(objectname)!=-1) ObjectDelete(objectname);
 
 objectname=StringConcatenate("Sell Equity ",Unique);
 if (Show_Sell)
 {
  if (ObjectFind(objectname)==-1)
  {
   ObjectCreate(objectname,OBJ_HLINE,Window,0,SellEquity[0]);
   ObjectSet(objectname,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet(objectname,OBJPROP_COLOR,OrangeRed);
  }
  ObjectSet(objectname,OBJPROP_PRICE1,SellEquity[0]);
 }
 else if (ObjectFind(objectname)!=-1) ObjectDelete(objectname); 
 
 if (Show_Info)
 {
  if (MaxDrawdown>0)
  {
   RecoveryFactor=(TotalEquity[0]-Deposit)/MaxDrawdown;
   objectname=StringConcatenate("Recovery Factor ",Unique);
   text=StringConcatenate("Recovery Factor: ",DoubleToStr(RecoveryFactor,2));
   LabelCreate(objectname,text,10);
  }
  objectname=StringConcatenate("Absolute Drawdown ",Unique);
  text=StringConcatenate("Absolute Drawdown: ",DoubleToStr(AbsDrawdown,2)," ",AccountCurrency());
  LabelCreate(objectname,text,30);
  if (MaxPeak>0)
  {
   objectname=StringConcatenate("Maximal Drawdown ",Unique);
   text=StringConcatenate("Maximal Drawdown: ",DoubleToStr(MaxDrawdown,2)," ",AccountCurrency()," (",DoubleToStr(100*MaxDrawdown/MaxPeak,2),"%)");
   LabelCreate(objectname,text,50);
  }
  objectname=StringConcatenate("Relative Drawdown ",Unique);
  text=StringConcatenate("Relative Drawdown: ",DoubleToStr(RelDrawdown,2),"% (",DoubleToStr(Drawdown,2)," ",AccountCurrency(),")");
  LabelCreate(objectname,text,70);
 }
 if (Alert_Drawdown>0 && Show_Total) AlertDrawdown();
 return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void LabelCreate(string name, string str, int y)
{
 if (ObjectFind(name)==-1)
 {
  ObjectCreate(name,OBJ_LABEL,Window,0,0);
  ObjectSet(name,OBJPROP_XDISTANCE,10);
  ObjectSet(name,OBJPROP_YDISTANCE,y);
  ObjectSet(name,OBJPROP_CORNER,1);
  ObjectSet(name,OBJPROP_COLOR,SlateGray);
 }
 ObjectSetText(name,str);
}
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
int Drawdown(double equity)
{
 if (equity<0) return(-1);
 if (AbsDrawdown<Deposit-equity) AbsDrawdown=Deposit-equity;
 if (equity>MaxProfit) MaxProfit=equity;
 if (MaxDrawdown<MaxProfit-equity)
 {
  MaxDrawdown=MaxProfit-equity;
  MaxPeak=MaxProfit;
  if (MaxPeak>0)
  {
   double relative=100*MaxDrawdown/MaxPeak;
   if (RelDrawdown<relative)
   {
    RelDrawdown=relative;
    Drawdown=MaxDrawdown;
   }
  }
 }
}
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
int AlertDrawdown()
{
 static int day;
 static double maxpeak,maxprofit,maxdrawdown,reldrawdown,drawdown,maxDD;
 static datetime time,timemaxprofit;
 int bar=0;
 double high,relative,level,curdrawdown;
 string name,drawdownstr,text;
 datetime timehigh,timelow;
    
 if (Current_Day) time=StrToTime(TimeToStr(Time[0],TIME_DATE));
 else time=Begin_Monitoring;
 if (time<Time_Begin) time=Time_Begin;
 bar=iBarShift(NULL,0,time);
 maxprofit=0.0;
 maxdrawdown=0.0;
 reldrawdown=0.0;
 maxDD=Alert_Drawdown;
 for (int i=bar;i>=0;i--)
 {
  if (TotalEquity[i]<0) return(-1);
  high=TotalEquity[i];
  if (high>maxprofit)
  {
   timemaxprofit=Time[i];
   maxprofit=high;
   maxdrawdown=0.0;
   reldrawdown=0.0;
   maxDD=Alert_Drawdown;
  }
  if (maxdrawdown<maxprofit-TotalEquity[i])
  {
   maxdrawdown=maxprofit-TotalEquity[i];
   maxpeak=maxprofit;
   timehigh=timemaxprofit;
   if (maxpeak>0)
   {
    relative=NormalizeDouble(100*maxdrawdown/maxpeak,1);
    if (reldrawdown<relative)
    {
     reldrawdown=relative;
     drawdown=maxdrawdown;
     timelow=Time[i];
    }
   }
  }
 }
 if (ObjectFind("up")>0)
 {
  if (ObjectGet("up",OBJPROP_PRICE1)<TotalEquity[0])
  {
   Alert("     ",TotalEquity[0]);
   ObjectSet("up",OBJPROP_PRICE1,TotalEquity[0]);
  }
 }
 if (ObjectFind("down")>0)
 {
  if (ObjectGet("down",OBJPROP_PRICE1)>TotalEquity[0])
  {
   Alert("     ",TotalEquity[0]);
   ObjectSet("down",OBJPROP_PRICE1,TotalEquity[0]);
  }
 }
 if (reldrawdown>maxDD)
 {
  maxDD=reldrawdown;
  if (maxDD>Max_Drawdown)
  {
   text=StringConcatenate("!      ",DoubleToStr(maxDD-Max_Drawdown,1),"%\n");
   text=StringConcatenate(text,"     ",DoubleToStr(Max_Drawdown,1),"%\n");
  }
  else
  {
   text=StringConcatenate("     ",DoubleToStr(maxDD-Alert_Drawdown,1),"%\n");
   text=StringConcatenate(text,"     ",DoubleToStr(Alert_Drawdown,1),"%\n");
  }
  drawdownstr=StringConcatenate(DoubleToStr(reldrawdown,1),"% (",DoubleToStr(drawdown,2)," ",AccountCurrency(),")");
  text=StringConcatenate(text,"       ",drawdownstr,"\n");
  text=StringConcatenate(text," : ",ShortName);
  Alert(text);
  name=StringConcatenate("Drawdown Line ",Unique);
  if (ObjectFind(name)==-1)
  {
   ObjectCreate(name,OBJ_TREND,Window,timehigh,maxpeak,timelow,maxpeak-drawdown);
   if (maxDD>Max_Drawdown) ObjectSet(name,OBJPROP_COLOR,Red);
   else ObjectSet(name,OBJPROP_COLOR,DarkOrange);
   ObjectSet(name,OBJPROP_WIDTH,2);
   ObjectSet(name,OBJPROP_RAY,false);
  }
  ObjectSetText(name,"       "+drawdownstr);
  ObjectSet(name,OBJPROP_PRICE1,maxpeak);
  ObjectSet(name,OBJPROP_PRICE2,maxpeak-drawdown);
  ObjectSet(name,OBJPROP_TIME1,timehigh);
  ObjectSet(name,OBJPROP_TIME2,timelow);
 }
 else
 {
  name=StringConcatenate("Drawdown Line ",Unique);
  if (ObjectFind(name)!=-1) ObjectDelete(name);
 }
 name=StringConcatenate("Begin Monitoring ",Unique);
 if (ObjectFind(name)==-1)
 {
  ObjectCreate(name,OBJ_VLINE,Window,time,0);
  ObjectSet(name,OBJPROP_COLOR,SlateGray);
  ObjectSetText(name,"Begin Monitoring");
 }
 ObjectSet(name,OBJPROP_TIME1,time);

 name=StringConcatenate("Max Profit ",Unique);
 level=NormalizeDouble(maxprofit,2);
 if (ObjectFind(name)==-1)
 {
  ObjectCreate(name,OBJ_TREND,Window,timemaxprofit,level,Time[0],level);
  ObjectSet(name,OBJPROP_COLOR,DodgerBlue);
  ObjectSet(name,OBJPROP_RAY,false);
  ObjectSetText(name,"Max Profit");
 }
 ObjectSet(name,OBJPROP_PRICE1,level);
 ObjectSet(name,OBJPROP_PRICE2,level);
 ObjectSet(name,OBJPROP_TIME1,timemaxprofit);
 ObjectSet(name,OBJPROP_TIME2,Time[0]);

 name=StringConcatenate("Alert Drawdown ",Unique);
 level=NormalizeDouble(maxprofit*(1-Alert_Drawdown/100),2);
 if (ObjectFind(name)==-1)
 {
  ObjectCreate(name,OBJ_TREND,Window,timemaxprofit,level,Time[0],level);
  ObjectSet(name,OBJPROP_COLOR,DarkOrange);
  ObjectSet(name,OBJPROP_RAY,false);
  ObjectSetText(name,"Alert Drawdown "+DoubleToStr(Alert_Drawdown,1)+"%");
 }
 ObjectSet(name,OBJPROP_PRICE1,level);
 ObjectSet(name,OBJPROP_PRICE2,level);
 ObjectSet(name,OBJPROP_TIME1,timemaxprofit);
 ObjectSet(name,OBJPROP_TIME2,Time[0]);

 name=StringConcatenate("Max Drawdown ",Unique);
 level=NormalizeDouble(maxprofit*(1-Max_Drawdown/100),2);
 if (ObjectFind(name)==-1)
 {
  ObjectCreate(name,OBJ_TREND,Window,timemaxprofit,level,Time[0],level);
  ObjectSet(name,OBJPROP_COLOR,Red);
  ObjectSet(name,OBJPROP_RAY,false);
  ObjectSetText(name,"Max Drawdown "+DoubleToStr(Max_Drawdown,1)+"%");
 }
 ObjectSet(name,OBJPROP_PRICE1,level);
 ObjectSet(name,OBJPROP_PRICE2,level);
 ObjectSet(name,OBJPROP_TIME1,timemaxprofit);
 ObjectSet(name,OBJPROP_TIME2,Time[0]);
 
 if (Show_Info)
 {
  curdrawdown=maxprofit-TotalEquity[0];
  name=StringConcatenate("Current Drawdown ",Unique);
  text=StringConcatenate("Current Drawdown: ",DoubleToStr(curdrawdown,2)," ",AccountCurrency()," (",DoubleToStr(100*curdrawdown/maxprofit,2),"%)");
  LabelCreate(name,text,90);
 }
}
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar)
{
 double size,close1,close2;
 string BQ,currency=AccountCurrency();
 
 if (currency=="") currency="USD";
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,0,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD")
   {
    close1=iClose(symbol,0,sbar);
    if (close1>0) size=size/close1;
   }
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(BQ,0,0)==0) break;
    int BQbar=iBarShift(BQ,0,tbar);
    close1=iClose(symbol,0,sbar);
    close2=iClose(BQ,0,BQbar);
    if (close1>0 && close2>0)
    {
     if (StringSubstr(BQ,0,3)=="USD") size=size/close2/close1;
     else size=size*close2/close1;
    }
   }
  } break;
  case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
  case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(BQ,0,0)==0)
  {
   BQ="USD"+currency;
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size*=close1;
  }
  else
  {
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size/=close1;
  }
 }
 return(size);
}
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
bool SetPosition(string name)
{
 double correction=0,price,priceopen,priceclose;
 int timeframe=0;
  
 int pos=StringFind(name,"!");
 if (pos!=-1) correction=StrToDouble(StringSubstr(name,pos+1));
 datetime timeopen=ObjectGet(name,OBJPROP_TIME1);
 datetime timeclose=ObjectGet(name,OBJPROP_TIME2);
 if (timeopen==timeclose) return(false);
 if (Use_M1) timeframe=PERIOD_M1;
 if (Open_Price)
 {
  price=iOpen(NULL,timeframe,iBarShift(NULL,timeframe,timeopen));
  if (ObjectGet(name,OBJPROP_PRICE1)!=price) ObjectSet(name,OBJPROP_PRICE1,price);
  price=iOpen(NULL,timeframe,iBarShift(NULL,timeframe,timeclose))+correction*MarketInfo(Symbol(),MODE_POINT);
  if (ObjectGet(name,OBJPROP_PRICE2)!=price) ObjectSet(name,OBJPROP_PRICE2,price);
 }
 else
 {
  price=iClose(NULL,timeframe,iBarShift(NULL,timeframe,timeopen));
  if (ObjectGet(name,OBJPROP_PRICE1)!=price) ObjectSet(name,OBJPROP_PRICE1,price);
  price=iClose(NULL,timeframe,iBarShift(NULL,timeframe,timeclose))+correction*MarketInfo(Symbol(),MODE_POINT);
  if (ObjectGet(name,OBJPROP_PRICE2)!=price) ObjectSet(name,OBJPROP_PRICE2,price);
 }
 if (timeopen<timeclose)
 {
  priceopen=ObjectGet(name,OBJPROP_PRICE1);
  priceclose=ObjectGet(name,OBJPROP_PRICE2);
 }
 else
 {
  timeopen=ObjectGet(name,OBJPROP_TIME2);
  timeclose=ObjectGet(name,OBJPROP_TIME1);
  priceopen=ObjectGet(name,OBJPROP_PRICE2);
  priceclose=ObjectGet(name,OBJPROP_PRICE1);
 }
 if (timeopen>TimeCurrent() || timeopen<Time_Begin || timeopen>Time_End) return(false);
 Trend_Total++;
 color objcolor=ObjectGet(name,OBJPROP_COLOR);
 string number=StringConcatenate("#",Trend_Total);
 string objname;
 if (Show_Vline)
 {
  objname=StringConcatenate(number," in");
  if (ObjectFind(objname)==-1)
  {
   Vline_Total++;
   ArrayResize(Vline_Name,Vline_Total);
   ArrayResize(Vline_Time,Vline_Total);
   Vline_Name[Vline_Total-1]=objname;
   Vline_Time[Vline_Total-1]=timeopen;
  }
  else
  {
   ObjectSet(objname,OBJPROP_TIME1,timeopen);
   ObjectSet(objname,OBJPROP_COLOR,objcolor);
  }
  objname=StringConcatenate(number," out");
  if (ObjectFind(objname)==-1)
  {
   Vline_Total++;
   ArrayResize(Vline_Name,Vline_Total);
   ArrayResize(Vline_Time,Vline_Total);
   Vline_Name[Vline_Total-1]=objname;
   Vline_Time[Vline_Total-1]=timeclose;
  }
  else
  {
   ObjectSet(objname,OBJPROP_TIME1,timeclose);
   ObjectSet(objname,OBJPROP_COLOR,objcolor);
  }
 }
 else
 {
  objname=StringConcatenate(number," in");
  if (ObjectFind(objname)!=-1)
  {
   Vline_Total++;
   ArrayResize(Vline_Name,Vline_Total);
   Vline_Name[Vline_Total-1]=objname;
  }
  objname=StringConcatenate(number," out");
  if (ObjectFind(objname)!=-1)
  {
   Vline_Total++;
   ArrayResize(Vline_Name,Vline_Total);
   Vline_Name[Vline_Total-1]=objname;
  }
 }
 string description=ObjectDescription(name);
 if (description=="")
 {
  if (Default_Symbols!="") description=Default_Symbols;
  else
  {
   description=Symbol();
   if (priceopen<priceclose) description=StringConcatenate(description,"+");
   else description=StringConcatenate(description,"-");
  }
  ObjectSetText(name,description);
 }
 int length=StringLen(description);
 pos=0;
 while (pos<length)
 {
  Pos_Total++;
  if (ArraySize(OpenBar)<Pos_Total)
  {
   ArrayResize(OpenBar,Pos_Total);
   ArrayResize(Instrument,Pos_Total);
   ArrayResize(Type,Pos_Total);
   ArrayResize(OpenPrice,Pos_Total);
   ArrayResize(Lots,Pos_Total);
   ArrayResize(CloseBar,Pos_Total);
   ArrayResize(ClosePrice,Pos_Total);
  }
  OpenBar[Pos_Total-1]=iBarShift(NULL,0,timeopen);
  CloseBar[Pos_Total-1]=iBarShift(NULL,0,timeclose);
  int start=pos;
  int char=0;
  while (char!=43 && char!=45 && char!=32)
  {
   pos++;
   char=StringGetChar(description,pos);
   if ((length-1)<pos) break;
  }
  Type[Pos_Total-1]=OP_BUY;
  if (char==43 && objcolor==Revers_Color) Type[Pos_Total-1]=OP_SELL;
  if (char==45 && objcolor!=Revers_Color) Type[Pos_Total-1]=OP_SELL;
  Instrument[Pos_Total-1]=StringSubstr(description,start,pos-start);
  if (Open_Price)
  {
   OpenPrice[Pos_Total-1]=iOpen(Instrument[Pos_Total-1],timeframe,iBarShift(Instrument[Pos_Total-1],timeframe,timeopen));
   ClosePrice[Pos_Total-1]=iOpen(Instrument[Pos_Total-1],timeframe,iBarShift(Instrument[Pos_Total-1],timeframe,timeclose));
  }
  else
  {
   OpenPrice[Pos_Total-1]=iClose(Instrument[Pos_Total-1],timeframe,iBarShift(Instrument[Pos_Total-1],timeframe,timeopen));
   ClosePrice[Pos_Total-1]=iClose(Instrument[Pos_Total-1],timeframe,iBarShift(Instrument[Pos_Total-1],timeframe,timeclose));
  }
  if (Type[Pos_Total-1]==OP_BUY) OpenPrice[Pos_Total-1]+=MarketInfo(Instrument[Pos_Total-1],MODE_POINT)*MarketInfo(Instrument[Pos_Total-1],MODE_SPREAD);
  if (correction!=0) ClosePrice[Pos_Total-1]+=correction*MarketInfo(Instrument[Pos_Total-1],MODE_POINT);
  pos++;
  if (StringGetChar(description,pos)==32 || (length-1)<pos) Lots[Pos_Total-1]=Default_Lot;
  else
  {
   start=pos;
   while(StringGetChar(description,pos)!=32)
   {
    pos++;
    if ((length-1)<pos) break;
   }
   Lots[Pos_Total-1]=StrToDouble(StringSubstr(description,start,pos-start));
  }
  pos++;
 }
}
//+------------------------------------------------------------------+